package ants.gui;

import ants.controller.Controller;
import ants.game.BoardInterface;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.Graphics;
import javax.swing.JFrame;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JTextArea;

public class AntGui extends JFrame {
   
    protected final AntPanel panel;
    protected final BoardInterface board;
    
    protected Controller controller;
    
    protected final JMenuBar menuBar = new JMenuBar();
    protected final JTextArea textArea = new JTextArea();
    
    protected static final int MIN_PX_SIZE = 10;

    public AntGui(BoardInterface board) {
        panel = new AntPanel(board);
        this.board = board;
        init();
    }

    private void init() {
        
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        
        setTitle("Ant example");
        
        JMenu antMenu = new JMenu("Ant menu");
        JMenuItem itemGenerate = new JMenuItem("Generate ants");
        antMenu.add(itemGenerate);
        itemGenerate.addActionListener((e) -> {
            if(controller != null){
                controller.generateAnts();
            }
        });
        
        menuBar.add(antMenu);
        
        add(menuBar, BorderLayout.NORTH);
        
        add(panel, BorderLayout.CENTER);
        panel.setMinimumSize(new Dimension(board.getSizeX() + MIN_PX_SIZE, board.getSizeY()*MIN_PX_SIZE));
        
        add(textArea, BorderLayout.SOUTH);
        textArea.setEditable(false);
        
        pack();
        
        setSize(600, 480);
        setVisible(true);
    }
    
    public void setAntCount(int count){
        textArea.setText("Ant count = " + count);
    }
    
    public void registerController(Controller controller){
        this.controller = controller;
    }

    @Override
    public void paint(Graphics g) {
        super.paint(g);
        setTitle("Ant gui " + System.currentTimeMillis() + " ms");
    }

    
}
