package ants.gui;

import ants.game.BoardInterface;
import java.awt.Color;
import java.awt.Graphics;
import javax.swing.JPanel;

public class AntPanel extends JPanel{
    
    protected BoardInterface board;

    public AntPanel(BoardInterface board) {
        this.board = board;
    }

    @Override
    public void paint(Graphics g) {
        // clear all
        g.setColor(Color.GRAY);
        g.fillRect(0, 0, getWidth(), getHeight());
        
        final int BX = board.getSizeX();
        final int BY = board.getSizeY();
        
        // estimate size
        int xs = (getWidth() - 1) / BX;
        int ys = (getHeight() - 1) / BY;
        
        int size = Math.min(xs, ys) - 1;
        int totalXSize = (size + 1) * BX + 1;
        int totalYSize = (size + 1) * BY + 1;
        
        g.setColor(Color.BLACK);
        g.fillRect(0, 0, totalXSize, totalYSize);
        
        for (int x = 0; x < board.getSizeX(); x++) {
            for (int y = 0; y < board.getSizeY(); y++) {
                int count = board.getCount(x, y);
                if (count < 0) {
                    g.setColor(Color.RED);
                } else if (count == 0) {
                    g.setColor(Color.DARK_GRAY);
                } else if (count == 1) {
                    g.setColor(Color.GREEN);
                } else {
                    g.setColor(Color.ORANGE);
                }

                g.fillRect((size + 1) * x + 1, (size + 1) * y + 1, size, size);
                
                g.setColor(Color.WHITE);
                g.drawString("" + count, (size + 1) * x -3 + size/2, (size + 1) * y + 5 + size / 2);
            }
        }
    }

   
    
}
